%     VIRTUAL FABRIC - программа для получения эффективных свойств текстильных композитов
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [NODES, ELEMENTS, RVE_Coordinates] = Create_RVE_Array(NODES, ELEMENTS, Node_Merge_Tolerance, RVE_Array_1, RVE_Array_2, RVE_Array_3, RVE_Size, RVE_Coordinates)

% Направление 1
if (RVE_Array_1 > 1)
    
    RVE_Coordinates(1,2) = RVE_Coordinates(1,2) + (RVE_Array_1 - 1) * RVE_Size(1);
    
    N_Nodes = size(NODES,1);
    
    NODES(RVE_Array_1*N_Nodes,1) = 0;
    
    for i=1:RVE_Array_1-1
        
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 1) = NODES((i-1)*N_Nodes + 1 : i*N_Nodes, 1) + ones(N_Nodes,1)*N_Nodes;
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 2) = NODES(1:N_Nodes, 2) + ones(N_Nodes,1)*i*RVE_Size(1);
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 3) = NODES((i-1)*N_Nodes + 1 : i*N_Nodes, 3);
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 4) = NODES((i-1)*N_Nodes + 1 : i*N_Nodes, 4);
        
    end
    
    N_Elements = size(ELEMENTS,1);
    
    ELEMENTS(RVE_Array_1*N_Elements,1) = 0;
    
    Mask = ELEMENTS(1:N_Elements, 5:size(ELEMENTS,2)) > 0;
    Mask = double(Mask);
    
    for i=1:RVE_Array_1-1
        
        ELEMENTS(i*N_Elements + 1 : (i+1)*N_Elements, 1) = ELEMENTS((i-1)*N_Elements + 1 : i*N_Elements, 1) + ones(N_Elements,1)*N_Elements;
        ELEMENTS(i*N_Elements + 1 : (i+1)*N_Elements, 2:4) = ELEMENTS((i-1)*N_Elements + 1 : i*N_Elements, 2:4);
        ELEMENTS(i*N_Elements + 1 : (i+1)*N_Elements, 5:size(ELEMENTS,2)) = ELEMENTS((i-1)*N_Elements + 1 : i*N_Elements, 5:size(ELEMENTS,2)) + Mask*N_Nodes;
        
    end
    
end

% Направление 2
if (RVE_Array_2 > 1)
    
    RVE_Coordinates(2,2) = RVE_Coordinates(2,2) + (RVE_Array_2 - 1) * RVE_Size(2);
    
    N_Nodes = size(NODES,1);
    
    NODES(RVE_Array_2*N_Nodes,1) = 0;
    
    for i=1:RVE_Array_2-1
        
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 1) = NODES((i-1)*N_Nodes + 1 : i*N_Nodes, 1) + ones(N_Nodes,1)*N_Nodes;
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 2) = NODES((i-1)*N_Nodes + 1 : i*N_Nodes, 2);
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 3) = NODES(1:N_Nodes, 3) + ones(N_Nodes,1)*i*RVE_Size(2);
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 4) = NODES((i-1)*N_Nodes + 1 : i*N_Nodes, 4);
        
    end
    
    N_Elements = size(ELEMENTS,1);
    
    ELEMENTS(RVE_Array_2*N_Elements,1) = 0;
    
    Mask = ELEMENTS(1:N_Elements, 5:size(ELEMENTS,2)) > 0;
    Mask = double(Mask);
    
    for i=1:RVE_Array_2-1
        
        ELEMENTS(i*N_Elements + 1 : (i+1)*N_Elements, 1) = ELEMENTS((i-1)*N_Elements + 1 : i*N_Elements, 1) + ones(N_Elements,1)*N_Elements;
        ELEMENTS(i*N_Elements + 1 : (i+1)*N_Elements, 2:4) = ELEMENTS((i-1)*N_Elements + 1 : i*N_Elements, 2:4);
        ELEMENTS(i*N_Elements + 1 : (i+1)*N_Elements, 5:size(ELEMENTS,2)) = ELEMENTS((i-1)*N_Elements + 1 : i*N_Elements, 5:size(ELEMENTS,2)) + Mask*N_Nodes;
        
    end
    
end

% Направление 3
if (RVE_Array_3 > 1)
    
    RVE_Coordinates(3,2) = RVE_Coordinates(3,2) + (RVE_Array_3 - 1) * RVE_Size(3);
    
    N_Nodes = size(NODES,1);
    
    NODES(RVE_Array_3*N_Nodes,1) = 0;
    
    for i=1:RVE_Array_3-1
        
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 1) = NODES((i-1)*N_Nodes + 1 : i*N_Nodes, 1) + ones(N_Nodes,1)*N_Nodes;
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 2) = NODES((i-1)*N_Nodes + 1 : i*N_Nodes, 2);
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 3) = NODES((i-1)*N_Nodes + 1 : i*N_Nodes, 3);
        NODES(i*N_Nodes + 1 : (i+1)*N_Nodes, 4) = NODES(1:N_Nodes, 4) + ones(N_Nodes,1)*i*RVE_Size(3);
        
    end
    
    N_Elements = size(ELEMENTS,1);
    
    ELEMENTS(RVE_Array_3*N_Elements,1) = 0;
    
    Mask = ELEMENTS(1:N_Elements, 5:size(ELEMENTS,2)) > 0;
    Mask = double(Mask);
    
    for i=1:RVE_Array_3-1
        
        ELEMENTS(i*N_Elements + 1 : (i+1)*N_Elements, 1) = ELEMENTS((i-1)*N_Elements + 1 : i*N_Elements, 1) + ones(N_Elements,1)*N_Elements;
        ELEMENTS(i*N_Elements + 1 : (i+1)*N_Elements, 2:4) = ELEMENTS((i-1)*N_Elements + 1 : i*N_Elements, 2:4);
        ELEMENTS(i*N_Elements + 1 : (i+1)*N_Elements, 5:size(ELEMENTS,2)) = ELEMENTS((i-1)*N_Elements + 1 : i*N_Elements, 5:size(ELEMENTS,2)) + Mask*N_Nodes;
        
    end
    
end

% Слияние узлов
[NODES, ELEMENTS] = Merge_Nodes(NODES, ELEMENTS, Node_Merge_Tolerance);
